unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Packet32seh;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TBitBtn;
    Button2: TBitBtn;
    Label4: TLabel;
    Edit2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    NumPack,NumByt: integer;
    FAdapterDescs: array[0..4-1] of ADAPTER_DESC;   //   :)
    FAdapterName: String;
    NADO: Boolean;
    FhAdapter: DWORD;
    FpPacket: LPPACKET;
    FuBuffer: Array [0..1520] oF ChaR;
    Bytes: DWord;
    LogF: TFileStream;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
 FadapterCount:Integer;
begin
 PacketGetAdapterNames(@FAdapterDescs, 4, @FAdapterCount); // . 
 FAdapterName:= StrPas (@FAdapterDescs[0].SzAdapterDesc); //  
 Edit2.Text:= FAdapterName; //   
 Button2.Enabled:= FalsE;
 NumPack:=0; NumByt:= 0; // ,  =0
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 i: integer;
 FuMac: array[0..5] of UCHAR;
begin
 Button2.Enabled:= true;
 Button1.Enabled:= false;
 FhAdapter:= PacketOpenAdapter(FAdapterDescs[0].szAdapterName);
 IF FhAdapter=0 then
  begin
   MessageDlg ('   .',mtError,[mbIgnore],0);
   exit;
  end;

 PacketAdapterDesc(LPADAPTER(FhAdapter), @FuBuffer[0], sizeof(FuBuffer), @i);
 PacketGetAddress(LPADAPTER(FhAdapter), @FuMac[0], 6, @i);
 PacketSetFilter(LPADAPTER(FhAdapter), NDIS_PACKET_TYPE_PROMISCUOUS);

 FpPacket := LPPACKET( PacketAllocatePacket(LPADAPTER(FhAdapter)) );
  IF (FpPacket= Nil) then
   begin
    MessageDlg ('',mtError,[mbNo],0);
    PacketCloseAdapter(LPADAPTER(FhAdapter));
    HALT;
   end;

 //     
 PacketInitPacket(FpPacket, @FuBuffer[0], 1520);
 {==,    ... ==}
 LogF:= TFileStream.Create(Edit1.Text,fmCreate oR fmOpenWrite);
 Nado:= True; //  ;)

 While Nado= TRUE do
  begin
   Application.ProcessMessages;
   PacketReceivePacket(LPADAPTER(FhAdapter), FpPacket, true, @Bytes);
   if Bytes>0 then
    LogF.Write(FuBuffer,Bytes);// 
   NumByt:= NumByt+Bytes;
   Label2.Caption:= IntToStr (NumByt);
   Application.ProcessMessages;
 end;
 LogF.Free; // 
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Button1.Enabled:= true;
 Button2.Enabled:= false;
 Nado:= False;
end;

end.
